﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace WindowsFormsApplication1
{
    public partial class GUI : Form
    {
        [DllImport("user32.dll")]
        static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        [DllImport("user32.dll", SetLastError = true)]
        static extern IntPtr FindWindow(string lpClassName, string
        lpWindowName);

        const int SW_HIDE = 0;
        const int SW_SHOWNOACTIVATE = 4;

        Thread HideD2Thread = new Thread(new ThreadStart(HideD2));
        Thread ShowD2Thread = new Thread(new ThreadStart(ShowD2));


        public GUI()
        {
            InitializeComponent();

            this.Resize += new EventHandler(Hide);
            notifyIcon1.DoubleClick += new EventHandler(Show);

            this.CenterToScreen();

            ShowD2Thread.Start();
            ShowD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            HideD2Thread.Start();
            HideD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
        }

        public void Hide(object sender, EventArgs ee)
        {
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.Hide();
            }

        }

        public void Show(object sender, EventArgs ee)
        {
                this.Show();
                this.Activate();
                this.BringToFront();
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            // Tray Hide
            ShowD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            HideD2Thread.Resume();
            System.Threading.Thread.Sleep(100);
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            // Tray Show
            HideD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            ShowD2Thread.Resume();
            System.Threading.Thread.Sleep(100);
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            // Tray Default
            HideD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            ShowD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Tray exit
            //ShowD2Thread.Resume();
            //System.Threading.Thread.Sleep(100);
            //ShowD2Thread.Abort();
            //HideD2Thread.Abort();

            Environment.Exit(0);
            //Application.Exit();
            //return;
        }

        static void ShowD2()
        {
            while (true)
            {
                System.Threading.Thread.Sleep(100);
                IntPtr hwndDiablo = FindWindow("Diablo II", "Diablo II");
                if (hwndDiablo != IntPtr.Zero)
                {
                    ShowWindow(hwndDiablo, SW_SHOWNOACTIVATE);
                }
            }
        }

        static void HideD2()
        {
            while (true)
            {
                System.Threading.Thread.Sleep(100);
                IntPtr hwndDiablo = FindWindow("Diablo II", "Diablo II");
                if (hwndDiablo != IntPtr.Zero)
                {
                    ShowWindow(hwndDiablo, SW_HIDE);
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Show
            HideD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            ShowD2Thread.Resume();
            System.Threading.Thread.Sleep(100);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // Hide
            ShowD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            HideD2Thread.Resume();
            System.Threading.Thread.Sleep(100);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            // Default
            HideD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
            ShowD2Thread.Suspend();
            System.Threading.Thread.Sleep(100);
        }        
    }
}
